/*=============================================================================

=============================================================================*/

#include "gdbmdefs.h"
#include "gdbmerrno.h"
#include "extern.h"
#include "getopt.h"

extern const char  *gdbm_strerror __P((gdbm_error));
gdbm_file_info *gdbm_h;

main 
(
   int  argc, 
   char *argv[]
)
{
   datum key_data, data_data, return_data;

   int  block_size = 0;
   char *file_name = NULL;

   char key_line[500], data_line[1000];

   file_name      = argv[1];
   key_data.dptr  = NULL;
   data_data.dptr = data_line;

   gdbm_h = gdbm_open
       (
          file_name, 
          block_size, 
          GDBM_READER, 
          00664, 
          NULL
       );
   if (gdbm_h == NULL)
   {
      printf("gdbm_open failed, %s\n", gdbm_strerror(gdbm_errno));
      exit (1);
   }

   key_data = gdbm_firstkey(gdbm_h);

   while(1)
   {
      if (key_data.dptr != NULL)
      {
         return_data = gdbm_fetch (gdbm_h, key_data);
         
         printf ("key is  ->%s\n",   key_data.dptr);
         printf ("data is ->%s\n\n", return_data.dptr);
         free (return_data.dptr);
      }
      else
      {
         exit(0);
      }
      if (key_data.dptr != NULL) 
      {
         free(key_data.dptr);
      }
      key_data = gdbm_nextkey(gdbm_h, key_data);
   }
}
