/*=============================================================================

=============================================================================*/

#include "gdbmdefs.h"
#include "gdbmerrno.h"
#include "extern.h"
#include "getopt.h"

extern const char  *gdbm_strerror __P((gdbm_error));
gdbm_file_info *gdbm_h;

main 
(
   int  argc, 
   char *argv[]
)
{
   datum key_data, data_data, return_data;

   int  block_size = 0;
   char *file_name = NULL;

   char *key_line, *data_line;

   file_name      = argv[1];
   key_data.dptr  = NULL;
   data_data.dptr = data_line;

   gdbm_h = gdbm_open
       (
          file_name, 
          block_size, 
          GDBM_NEWDB,
          00664, 
          NULL
       );
   if (gdbm_h == NULL)
   {
      printf("gdbm_open failed, %s\n", gdbm_strerror(gdbm_errno));
      exit (1);
   }

   key_line        = "first key";
   data_line       = "first data entry";

   key_data.dptr   = key_line;
   key_data.dsize  = strlen(key_line)+1;
   data_data.dptr  = data_line;
   data_data.dsize = strlen(data_line)+1;

   if(
      gdbm_store
      (
         gdbm_h, key_data, data_data, GDBM_REPLACE
      )
      != 0
   )
   {
      printf ("Item not inserted. \n");
   }
   
   exit(0);
}
